package com.bonus.canteen.core.user.service.impl;

import java.util.List;

import com.bonus.canteen.core.common.enums.YesOrNoEnum;
import com.bonus.common.core.exception.ServiceException;
import com.bonus.common.core.utils.DateUtils;
import com.bonus.common.security.utils.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.bonus.canteen.core.user.mapper.UserAddrMapper;
import com.bonus.canteen.core.user.domain.UserAddr;
import com.bonus.canteen.core.user.service.IUserAddrService;

/**
 * 地址信息Service业务层处理
 * 
 * @author xsheng
 * @date 2025-04-14
 */
@Service
public class UserAddrServiceImpl implements IUserAddrService {
    @Autowired
    private UserAddrMapper userAddrMapper;

    /**
     * 查询地址信息
     * 
     * @param id 地址信息主键
     * @return 地址信息
     */
    @Override
    public UserAddr selectUserAddrById(Long id) {
        return userAddrMapper.selectUserAddrById(id);
    }

    /**
     * 查询地址信息列表
     * 
     * @param userAddr 地址信息
     * @return 地址信息
     */
    @Override
    public List<UserAddr> selectUserAddrList(UserAddr userAddr) {
        userAddr.setUserId(SecurityUtils.getUserId());
        return userAddrMapper.selectUserAddrList(userAddr);
    }

    /**
     * 新增地址信息
     * 
     * @param userAddr 地址信息
     * @return 结果
     */
    @Override
    public int insertUserAddr(UserAddr userAddr) {
        userAddr.setCreateTime(DateUtils.getNowDate());
        userAddr.setUserId(SecurityUtils.getUserId());
        try {
            return userAddrMapper.insertUserAddr(userAddr);
        } catch (Exception e) {
            throw new ServiceException("错误信息描述");
        }
    }

    /**
     * 修改地址信息
     * 
     * @param userAddr 地址信息
     * @return 结果
     */
    @Override
    public int updateUserAddr(UserAddr userAddr) {
        userAddr.setUpdateTime(DateUtils.getNowDate());
        userAddr.setUserId(SecurityUtils.getUserId());
        try {
            return userAddrMapper.updateUserAddr(userAddr);
        } catch (Exception e) {
            throw new ServiceException("错误信息描述");
        }
    }

    @Override
    public int updateUserAddrAsDefault(UserAddr userAddr) {
        userAddr.setUpdateTime(DateUtils.getNowDate());
        try {
            userAddrMapper.updateUserAddrAsNotDefault(userAddr.getUserId(), YesOrNoEnum.NO.key());
            userAddrMapper.updateUserAddrAsDefault(userAddr.getUserId(), userAddr.getAddrId(), YesOrNoEnum.YES.key());
            return 1;
        } catch (Exception e) {
            throw new ServiceException("设置默认地址失败");
        }
    }

    /**
     * 批量删除地址信息
     * 
     * @param ids 需要删除的地址信息主键
     * @return 结果
     */
    @Override
    public int deleteUserAddrByIds(Long[] ids) {
        return userAddrMapper.deleteUserAddrByIds(ids);
    }

    /**
     * 删除地址信息信息
     * 
     * @param id 地址信息主键
     * @return 结果
     */
    @Override
    public int deleteUserAddrById(Long id) {
        return userAddrMapper.deleteUserAddrById(id);
    }
}
